org.eclipse.jetty.util

## Class StringUtil

- java.lang.Object
- - org.eclipse.jetty.util.StringUtil

    public class StringUtil
    extends Object

Fast String Utilities. These string utilities provide both conveniance methods and performance improvements over most standard library versions. The main aim of the optimizations is to avoid object creation unless absolutely required.

### Field Summary

Fields
`static String` `__ISO_8859_1`
`static Charset` `__ISO_8859_1_CHARSET`
`static String` `__LINE_SEPARATOR`
`static String` `__UTF16`
`static String` `__UTF8`
`static Charset` `__UTF8_CHARSET`
`static String` `__UTF8Alt`
`static String` `ALL_INTERFACES`
`static String` `CRLF`

### Constructor Summary

Constructors
Constructor and Description
`StringUtil()`

### Method Summary

Methods
`static void` `append(StringBuilder buf, byte b, int base)` append hex digit
`static void` `append(StringBuilder buf, String s, int offset, int length)` Append substring to StringBuilder
`static void` `append2digits(StringBuffer buf, int i)`
`static void` `append2digits(StringBuilder buf, int i)`
`static String` `asciiToLowerCase(String s)` fast lower case conversion.
`static boolean` `endsWithIgnoreCase(String s, String w)`
`static boolean` `equals(String s, char[] buf, int offset, int length)`
`static byte[]` `getBytes(String s)`
`static byte[]` `getBytes(String s, String charset)`
`static int` `indexFrom(String s, String chars)` returns the next index of a character from the chars string
`static boolean` `isUTF8(String charset)`
`static String` `nonNull(String s)` Return a non null string.
`static String` `printable(byte[] b)`
`static String` `printable(String name)`
`static String` `replace(String s, String sub, String with)` replace substrings within string.
`static String` `sidBytesToString(byte[] sidBytes)` Converts a binary SID to a string SID http://en.wikipedia.org/wiki/Security_Identifier S-1-IdentifierAuthority-SubAuthority1-SubAuthority2-...-SubAuthorityn
`static byte[]` `sidStringToBytes(String sidString)` Converts a string SID to a binary SID http://en.wikipedia.org/wiki/Security_Identifier S-1-IdentifierAuthority-SubAuthority1-SubAuthority2-...-SubAuthorityn
`static boolean` `startsWithIgnoreCase(String s, String w)`
`static String` `toString(byte[] b, int offset, int length, String charset)`
`static String` `toUTF8String(byte[] b, int offset, int length)`
`static String` `unquote(String s)` Remove single or double quotes.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### ALL_INTERFACES

    public static final String ALL_INTERFACES

See Also:
  Constant Field Values

#### CRLF

    public static final String CRLF

See Also:
  Constant Field Values

#### __LINE_SEPARATOR

    public static final String __LINE_SEPARATOR

#### __ISO_8859_1

    public static final String __ISO_8859_1

See Also:
  Constant Field Values

#### __UTF8

    public static final String __UTF8

See Also:
  Constant Field Values

#### __UTF8Alt

    public static final String __UTF8Alt

See Also:
  Constant Field Values

#### __UTF16

    public static final String __UTF16

See Also:
  Constant Field Values

#### __UTF8_CHARSET

    public static final Charset __UTF8_CHARSET

#### __ISO_8859_1_CHARSET

    public static final Charset __ISO_8859_1_CHARSET

### Constructor Detail

#### StringUtil

    public StringUtil()

### Method Detail

#### asciiToLowerCase

    public static String asciiToLowerCase(String s)

fast lower case conversion. Only works on ascii (not unicode)

Parameters:
  `s` - the string to convert
Returns:
  a lower case version of s

#### startsWithIgnoreCase

    public static boolean startsWithIgnoreCase(String s,
                               String w)

#### endsWithIgnoreCase

    public static boolean endsWithIgnoreCase(String s,
                             String w)

#### indexFrom

    public static int indexFrom(String s,
                String chars)

returns the next index of a character from the chars string

#### replace

    public static String replace(String s,
                 String sub,
                 String with)

replace substrings within string.

#### unquote

    public static String unquote(String s)

Remove single or double quotes.

#### append

    public static void append(StringBuilder buf,
              String s,
              int offset,
              int length)

Append substring to StringBuilder

Parameters:
  `buf` - StringBuilder to append to
  `s` - String to append from
  `offset` - The offset of the substring
  `length` - The length of the substring

#### append

    public static void append(StringBuilder buf,
              byte b,
              int base)

append hex digit

#### append2digits

    public static void append2digits(StringBuffer buf,
                     int i)

#### append2digits

    public static void append2digits(StringBuilder buf,
                     int i)

#### nonNull

    public static String nonNull(String s)

Return a non null string.

Parameters:
  `s` - String
Returns:
  The string passed in or empty string if it is null.

#### equals

    public static boolean equals(String s,
                 char[] buf,
                 int offset,
                 int length)

#### toUTF8String

    public static String toUTF8String(byte[] b,
                      int offset,
                      int length)

#### toString

    public static String toString(byte[] b,
                  int offset,
                  int length,
                  String charset)

#### isUTF8

    public static boolean isUTF8(String charset)

#### printable

    public static String printable(String name)

#### printable

    public static String printable(byte[] b)

#### getBytes

    public static byte[] getBytes(String s)

#### getBytes

    public static byte[] getBytes(String s,
                  String charset)

#### sidBytesToString

    public static String sidBytesToString(byte[] sidBytes)

Converts a binary SID to a string SID http://en.wikipedia.org/wiki/Security_Identifier S-1-IdentifierAuthority-SubAuthority1-SubAuthority2-...-SubAuthorityn

#### sidStringToBytes

    public static byte[] sidStringToBytes(String sidString)

Converts a string SID to a binary SID http://en.wikipedia.org/wiki/Security_Identifier S-1-IdentifierAuthority-SubAuthority1-SubAuthority2-...-SubAuthorityn